


void drawLabels(){
  
  cam.beginHUD();
  
  drawTitle();
  drawControls();
  drawCredits();
  
  cam.endHUD();
   
  drawAxisLabels();
}

void drawTitle(){
  gFont2 = createFont("Helvetica", 22);
  textAlign(LEFT, CENTER);
  emissive(255);
  fill(255);
  textFont(gFont2);
  text("Visualizing SPL Book Age, Popularity and Adoption Rates", -90, 30);
}

void drawControls(){
  gFont2 = createFont("Helvetica", 16);
  textAlign(LEFT, CENTER);
  emissive(255);
  fill(255);
  textFont(gFont2);
  text(getColorSchemeText(), -90, 50);
  text("{ more coming soon }", -90, 70); // TODO: REMOVE UPON NEXT ITERATION
}

void drawCredits(){
  emissive(100); 
  textSize(14);
  textAlign(RIGHT, CENTER);
  text("Mat 259 3D Project", 1100, 930);
  text("Winter 2016", 1100, 950);
  text("Thomas Hervey", 1100, 970);
}

void drawAxisLabels(){
  drawXLabels();
  drawYLabels(); // ******* FIX THIS DISTRIBUTION
  drawZLabels();
}

void drawXLabels(){
  pushMatrix();
  for(int i=0; i<numRows/100; i++){
    String pubDate = dataRecords[i*100].publishDate;
    stroke(255);
    text(pubDate, i*300 - leftOffset, 1000, 20);
  }
 popMatrix();
}

void drawYLabels(){
  pushMatrix();
  rotateX(-PI/2);
  for(int i=min_checkout; i<max_checkout/10; i++){
    int checkoutCount = min_checkout + i*(max_checkout/10);
    stroke(255);
    text(checkoutCount, -leftOffset, -checkoutCount, 1000);
    text(checkoutCount, leftOffset, -checkoutCount, 0);
  }
  popMatrix();
}

void drawZLabels(){
  pushMatrix();
  rotateY(-PI/2);
  rotateZ(PI/2);
  for(int i=0; i<10; i++){
    stroke(255);
    textAlign(CENTER, CENTER);
    text(2006+i, dataRecords[0].yearMapped[i], 20, leftOffset);
  }
  popMatrix();
}