class DataRecord{

  int bib, isbn, publishOrder, ageFull, ageCheckouts, 
  y2006, y2007, y2008, y2009, y2010, y2011, y2012, y2013, 
  y2014, y2015, totalCheckout;
  float adoption;
  String bookType, title, publishDate;

  // mapping arrays
  int[] pubMapped;
  int[] countMapped;
  int[] yearMapped;
  float adoptionMapped = 0;
  
  // colors
  color dataPointColor;

  DataRecord(int nbib, int nisbn, String nbookType, String ntitle, String npublishDate, 
    int npublishOrder, float nadoption, int nageFull, int nageCheckouts, int n2006, 
    int n2007, int n2008, int n2009, int n2010, int n2011, int n2012, int n2013, 
    int n2014, int n2015, int ntotalCheckout){
    bib = nbib;
    isbn = nisbn;
    bookType = nbookType;
    title = ntitle;
    publishDate = npublishDate;
    publishOrder = npublishOrder;
    adoption = nadoption;
    ageFull = nageFull;
    ageCheckouts = nageCheckouts;
    y2006 = n2006;
    y2007 = n2007;
    y2008 = n2008;
    y2009 = n2009;
    y2010 = n2010;
    y2011 = n2011;
    y2012 = n2012;
    y2013 = n2013;
    y2014 = n2014;
    y2015 = n2015;
    totalCheckout = ntotalCheckout;
    
  }

  void mapValues(){
    // initialize mapped arrays
    pubMapped = new int[10];
    countMapped = new int[10];
    yearMapped = new int[10];

    //for each data point in data record
    for (int j=0; j<10; j++){
      // map newly created values
      pubMapped[j]      = (int)map(publishOrder, min_publishOrder, max_publishOrder, 0, 3*numRows);
      countMapped[j]    = (int)map(getYearCount(j), min_checkout, max_checkout, 0, 1000);
      yearMapped[j]     = (int)map(getYear(j), min_year, max_year, 1000, 0);
    }
    // map adoption
    adoptionMapped = (int)map(adoption, min_adoption, max_adoption, 0, 1000);
  }
  
  // countMapped mapping helper
  private int getYearCount(int j){
    int yearValue = 10000;
    switch (j) {
    case 0: return y2006;
    case 1: return y2007;
    case 2: return y2008;
    case 3: return y2009;
    case 4: return y2010;
    case 5: return y2011;
    case 6: return y2012;
    case 7: return y2013;
    case 8: return y2014;
    case 9: return y2015;
    } return yearValue;
  }
  
  // yearMapped mapping helper
  private int getYear(int j){
    int year = 10000;
    switch (j) {
    case 0: return 2006;
    case 1: return 2007;
    case 2: return 2008;
    case 3: return 2009;
    case 4: return 2010;
    case 5: return 2011;
    case 6: return 2012;
    case 7: return 2013;
    case 8: return 2014;
    case 9: return 2015;
    } return year;
  }
  
  void displayTitle(float posX, float posY, float posZ){
    textAlign(CENTER, CENTER);
    textSize(10);
    fill(255);
    text(title, posX-10, posY-10);
  }
  
}